﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:msxsl="urn:schemas-microsoft-com:xslt" exclude-result-prefixes="msxsl"
    xmlns:fs="urn:fs_common"
    xmlns:script="urn:my-scripts"
>
  <xsl:output method="text" indent="no" encoding="utf-8" />

  <!-- 外部XSLTからスクリプトを読み込む -->
  <xsl:include href="./SampleScript.xslt" />
  
  <!-- 引数、初期値は -->
  <xsl:param name="TableID" select="tableA" />

  <!-- 外部XMLを始めに読み込む -->
  <xsl:variable name="source" select="document('../xml/sources.xml')" />
  
  <!-- Start -->
  <xsl:template match="/">
    <xsl:apply-templates select="//table[@name = $TableID]" />
  </xsl:template>

  <!--テーブル名出力テンプレート-->
  <xsl:template match="//table">
    <!-- テーブル名をクラス名にする -->
    <xsl:text>public class </xsl:text>
    <xsl:value-of select="script:Proper(@name)" />
    <xsl:text> {</xsl:text>

    <!--カラムの出力-->
    <xsl:apply-templates select="//column" />    
    
    <xsl:text>}</xsl:text>
  </xsl:template>

  <!--カラム出力テンプレート-->
  <xsl:template match="//column">
    <xsl:variable name="comment" select="@comment" />
    <xsl:variable name="type" select="@type" />
    <xsl:variable name="size" select="@size" />

    <xsl:variable name="MemberName" select="fs:Proper(@name)" />
    <xsl:variable name="LocalName" select="fs:GetLocalName(@name)" />
    <xsl:variable name="java_type" select="fs:GetTypeText($type, $size)" />
    <xsl:variable name="source"
      select="$source//source[@id='entity_sample']" />

    <xsl:value-of disable-output-escaping="yes"
      select="fs:Format($source,
                    $comment, $java_type, $LocalName, $MemberName)" />
  </xsl:template>

</xsl:stylesheet>
